<?php
/* hl2mixi Ver0.5くらい 2009-05-30 (C) 2009 Akkiesoft. */

/* 次のライブラリが必要です。
   * XML/RSS
        http://pear.php.net/package/XML_RSS
   * qdsmtp
        http://hal456.net/qdsmtp/
   * qdmail
        http://hal456.net/qdmail/
   * htmlsql.class.php(snoopy.class.php)
        http://www.jonasjohn.de/lab/htmlsql.htm
*/


/* -- 設定項目 ---------------------------------------------- */

	/* RSSのURL */
	$rssurl = "";

	/* mixiに登録しているケータイのメールアドレス */
	$mail_from = "";

	/* mixiの投稿アドレス */
	$mail_to = "";

	/* 日記の冒頭の一文(ご自由に) */
	$mailhead = "※ブログからの転送です。";

	/* 画像の転送を許可するドメイン(正規表現) */
	$pic_patterns = array(
//		'/f\.hatena\.ne\.jp/',		// はてなフォトライフの例
	);

/* ---------------------------------------------------------------- */

	require_once("XML/RSS.php");
	require_once("qdsmtp.php");
	require_once("qdmail.php");
	include_once("snoopy.class.php");
	include_once("htmlsql.class.php");


	$dir = dirname(__FILE__);			/* スクリプトを置いているディレクトリ */
	$datfile = $dir . "/latest.txt";

function getDiaryBody($body)
{
	$body2 = explode("\n", $body);
	$ret = "";
	foreach($body2 as $line) {
		$line = ltrim($line, "\t");
		if ( preg_match('/niconico\/(sm|nm)([0-9]+)/', $line, $matches) ) {
			$ret .= "<externalvideo src=\"NC:".$matches[1].$matches[2]."\">\n";
		} else if ( preg_match('/youtube\.com\/v\/([-_0-9a-zA-Z]+)/', $line, $matches) ) {
			$ret .= "<externalvideo src=\"YT:".$matches[1].":D\">\n";
		} else {
			$ret .= $line."\n";
		}
	}
	return strip_tags($ret, '<externalvideo>');
}

	/* -- RSSの取得 -- */
	$rss =& new XML_RSS($rssurl);
	$rss->parse();
	$rssdata = $rss->getItems();
	$rssinfo = $rss->getChannelInfo();
	$blogname = $rssinfo['title'];

	/* -- ステータスファイルの読み込み -- */
	if (file_exists($datfile)) {
		$latest = file_get_contents($datfile);
	} else {
		$latest = strtotime($rssdata[0]['pubdate']);
		file_put_contents($datfile, $latest);
		print(
			"RSSの監視を開始しました。\n" .
			"最新のエントリー投稿日: ". $rssdata[0]['pubdate'] . "\n" .
			"これより新しいエントリから通知メールを送信します。"
		);
		exit;
	}

	$out = "";
	$cnt = 0;
	foreach ($rss->getItems() as $item) {
		/* -- 記事投稿日時の取得 -- */
		$date  = strtotime($item['pubdate']);
		if ($date <= $latest) { break; }

		/* -- その他記事データの取得 -- */
		$title = $item['title'];
		$link  = $item['link'];
		$ndate = date('n月j日 G時i分 投稿', $date);
		$text = getDiaryBody($item['description']);

		/* -- 画像ファイルの処理 -- */
		$wsql = new htmlsql();
		if (!$wsql->connect('string', $item['description'])){
			print 'Error while connecting: ' . $wsql->error;
			exit;
		}
		if (!$wsql->query('SELECT * FROM img')){
			print "Query error: " . $wsql->error; 
			exit;
		}
		foreach($wsql->fetch_array() as $row){
			if ($cnt < 3) {
				foreach ($pic_patterns as $pattern) {
					if ( preg_match($pattern, $row['src'], $match) ) {
						$imgurlinfo = pathinfo($row['src']);
						$pext  = $imgurlinfo['extension'];
						$pname = substr($imgurlinfo['basename'], 0, strrpos($imgurlinfo['basename'], '.')) . ".jpg";

						if ($pext == "jpg" || $pext == "JPG" || $pext == "jpeg" || $pext == "JPEG") {
							file_put_contents($pname, file_get_contents($row['src']));
						} else {
							if ($pext == "gif" || $pext == "GIF") {
								if (function_exists('imagecreatefromgif')) {
									$hndl = imagecreatefromgif( $row['src'] );
								}
							} else if ( $pext == "png" || $pext == "PNG" ) {
								if ( function_exists('imagecreatefrompng') ) {
									$hndl = imagecreatefrompng( $row['src'] );
								}
							}
							if ($hndl) { imagejpeg($hndl, $pname, 90); } else { return; }
							imagedestroy($hndl);
						}
						$imgurl[] = array($pname, $pname);
						if ( $cnt++ == 2 ) { break; }
					}
				}
			}
		}

		/* -- メール本文に追記 -- */
		$out .= "▼$title($ndate)\n$link\n$text\n\n";
	}

	if ( $out == "" ) {
		exit;			// 更新無し、終了
	}

	/* -- ステータスファイルの更新 -- */
	$latest = strtotime($rssdata[0]['pubdate']);
	file_put_contents($datfile, $latest);

	/* -- 冒頭一文の付記 -- */
	$out = $mailhead . "\n\n" . $out;
	$out .="# Headline to mixi Ver.0.5くらい by Akkiesoft. #\n";

	/* -- メール送信 -- */
	$mail = & new Qdmail();
	$mail -> smtp(true);
	$param = array(
	    'host'    => 'localhost',
	    'port'    => 25 ,
	    'from'    => $mail_from,
	    'protocol'=> 'SMTP',
	    'user'    => '',    'pass'    => '',
	);
	$mail -> smtpServer($param);
	$mail -> to( $mail_to , '' );
	if (isset($imgurl)) {
		$mail -> attach($imgurl);
	}
	$mail -> subject( $rssdata[0]['title'] );
	$mail -> text( $out );
	$mail -> from( $mail_from , "" );
	$mail ->send();

	/* -- 画像があった場合は削除 -- */
	if (isset($imgurl)) {
		foreach ($imgurl as $url) {
			unlink($url[0]);
		}
	}

	exit();
?>

